SystemOrganization addCategory: #'Pier-Book-Structures'!
SystemOrganization addCategory: #'Pier-Book-Utilities'!
SystemOrganization addCategory: #'Pier-Book-Latex'!

PRStructure subclass: #BONote
	instanceVariableNames: 'email note timestamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book-Structures'!

!BONote class methodsFor: 'testing' stamp: 'lr 5/3/2009 12:45'!
canBeChildOf: aStructureClass
	^ aStructureClass includesBehavior: BOPublication! !

!BONote class methodsFor: 'descriptions' stamp: 'lr 5/3/2009 13:05'!
descriptionConfirmation
	^ MABooleanDescription new
		addCondition: (MACondition selector: #yourself)
			labelled: 'Please, confirm submission by clicking the checkbox';
		checkboxLabel: 'Confirm submission by clicking the checkbox';
		propertyAt: #public put: true;
		accessor: #confirmation;
		label: 'Confirmation';
		priority: 600;
		beEditable;
		yourself! !

!BONote class methodsFor: 'descriptions' stamp: 'lr 5/3/2009 13:04'!
descriptionEmail
	^ MAStringDescription new
		addCondition: (MACondition selector: #matches: argument: '#*@#*.#*')
			labelled: 'Please make sure to enter a valid E-Mail';
	 	propertyAt: #public put: true;
		accessor: #email;
		label: 'E-Mail';
		priority: 500;
		beRequired;
		beEditable;
		yourself! !

!BONote class methodsFor: 'descriptions' stamp: 'lr 5/3/2009 13:05'!
descriptionNote
	^ MAMemoDescription new
	 	propertyAt: #public put: true;
		accessor: #note;
		priority: 550;
		label: 'Note';
		lineCount: 5;
		beRequired;
		beEditable;
		yourself! !

!BONote class methodsFor: 'testing' stamp: 'lr 5/3/2009 12:43'!
isAbstract
	^ false! !

!BONote class methodsFor: 'accessing' stamp: 'lr 5/3/2009 12:42'!
label
	^ 'Book Note'! !

!BONote methodsFor: 'accessing-dynamic' stamp: 'lr 5/3/2009 12:24'!
author
	^ self email copyUpTo: $@! !

!BONote methodsFor: 'accessing' stamp: 'lr 5/3/2009 13:05'!
confirmation
	^ false! !

!BONote methodsFor: 'accessing' stamp: 'lr 5/3/2009 13:05'!
confirmation: aBoolean! !

!BONote methodsFor: 'accessing-dynamic' stamp: 'lr 5/3/2009 12:45'!
document
	^ PRDocument new
		add: (PRParagraph with: (PRText content: self author));
		add: (PRPreformatted withAll: (self note lines
			collect: [ :each | PRText content: each ]));
		yourself! !

!BONote methodsFor: 'accessing' stamp: 'lr 5/3/2009 12:24'!
email
	^ email! !

!BONote methodsFor: 'accessing' stamp: 'lr 5/3/2009 12:24'!
email: aString 
	email := aString! !

!BONote methodsFor: 'initialization' stamp: 'lr 5/3/2009 12:29'!
initialize
	super initialize.
	email := String new.
	note := String new.
	timestamp := TimeStamp now! !

!BONote methodsFor: 'testing' stamp: 'lr 5/3/2009 12:10'!
isNote
	^ true! !

!BONote methodsFor: 'accessing' stamp: 'lr 5/3/2009 12:09'!
note
	^ note! !

!BONote methodsFor: 'accessing' stamp: 'lr 5/3/2009 12:09'!
note: aString 
	note := aString! !

!BONote methodsFor: 'accessing-dynamic' stamp: 'lr 5/3/2009 12:29'!
timestamp
	^ timestamp! !

!PRStructure methodsFor: '*pier-book' stamp: 'lr 5/3/2009 12:10'!
isNote
	^ false! !

!PRStructure methodsFor: '*pier-book' stamp: 'lr 4/24/2009 11:56'!
isPublication
	^ false! !

PRLink subclass: #BOIndexLink
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book-Utilities'!

!BOIndexLink class methodsFor: 'testing' stamp: 'lr 5/1/2009 22:08'!
isAbstract
	^ false! !

!BOIndexLink class methodsFor: 'testing' stamp: 'lr 5/1/2009 22:09'!
isValidReference: aString
	^ aString beginsWith: 'index:'! !

!BOIndexLink methodsFor: 'visiting' stamp: 'lr 5/1/2009 22:09'!
accept: aVisitor
	aVisitor visitIndexLink: self! !

!BOIndexLink methodsFor: 'accessing' stamp: 'lr 5/1/2009 22:13'!
title
	^ super title copyAfter: $:! !

PRRawView subclass: #POLatexView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book-Latex'!

!POLatexView class methodsFor: 'testing' stamp: 'lr 5/13/2009 09:01'!
isAbstract
	^ false! !

!POLatexView class methodsFor: 'testing' stamp: 'lr 5/13/2009 09:02'!
isValidIn: aContext
	^ (super isValidIn: aContext) and: [ aContext structure isPublication ]! !

!POLatexView class methodsFor: 'converting' stamp: 'lr 5/13/2009 09:02'!
label
	^ 'LaTeX'! !

!POLatexView methodsFor: 'rendering' stamp: 'lr 5/13/2009 11:20'!
renderContentOn: aResponse
	aResponse contentType: 'text/latex'.
	BOLatexWriter
		write: self context structure
		to: aResponse stream! !

PRWidget subclass: #BONoteWidget
	instanceVariableNames: 'component command note'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book-Utilities'!

!BONoteWidget class methodsFor: 'testing' stamp: 'lr 5/3/2009 12:41'!
isAbstract
	^ false! !

!BONoteWidget class methodsFor: 'accessing' stamp: 'lr 5/3/2009 12:41'!
label
	^ 'Book Notes'! !

!BONoteWidget methodsFor: 'private' stamp: 'lr 5/3/2009 12:55'!
buildCommand
	^ (self context
		structure: self note
		command: self note editCommandClass new)
			command! !

!BONoteWidget methodsFor: 'private' stamp: 'lr 5/3/2009 12:54'!
buildComponent
	^ (self buildDescription asComponentOn: self command)
		onAnswer: [ :result | self execute: result ];
		addValidatedForm;
		yourself! !

!BONoteWidget methodsFor: 'private' stamp: 'lr 5/3/2009 12:55'!
buildDescription
	^ self command description select: [ :each | each propertyAt: #public ifAbsent: [ false ] ]! !

!BONoteWidget methodsFor: 'private' stamp: 'lr 5/3/2009 12:56'!
buildNote
	^ BONote new
		title: self context structure title;
		yourself! !

!BONoteWidget methodsFor: 'accessing' stamp: 'lr 5/3/2009 12:54'!
children
	^ Array with: self component! !

!BONoteWidget methodsFor: 'accessing' stamp: 'lr 5/3/2009 12:55'!
command
	^ command ifNil: [ command := self buildCommand ]! !

!BONoteWidget methodsFor: 'accessing' stamp: 'lr 5/3/2009 12:54'!
component
	^ component ifNil: [ component := self buildComponent ]! !

!BONoteWidget methodsFor: 'actions' stamp: 'lr 5/3/2009 13:02'!
execute: anEditCommand
	| addCommand |
	note := component := command := nil.
	anEditCommand ifNil: [ ^ self ].
	addCommand := PRAddCommand new.
	self context command: addCommand.
	addCommand
		name: (addCommand
			uniqueName: 'note'
			in: self context structure);
		type: BONote;
		beUnchecked;
		execute.
	self context
		structure: addCommand answer structure
		command: anEditCommand.
	anEditCommand
		beUnchecked;
		execute! !

!BONoteWidget methodsFor: 'accessing' stamp: 'lr 5/3/2009 12:57'!
note
	^ note ifNil: [ note := self buildNote ]! !

!BONoteWidget methodsFor: 'accessing' stamp: 'lr 5/3/2009 12:40'!
notes
	^ (self context enumerator
		select: [ :each | each isNote ])
		asSortedCollection: [ :a :b | a timestamp > b timestamp ]! !

!BONoteWidget methodsFor: 'rendering-adding' stamp: 'lr 5/3/2009 17:09'!
renderAddOn: html
	html div class: 'addnote'; with: [
		html heading: 'Add a Note'.
		html render: self component ]! !

!BONoteWidget methodsFor: 'rendering' stamp: 'lr 5/3/2009 17:14'!
renderContentOn: html
	(BONote canBeChildOf: self context structure class)
		ifFalse: [ ^ self ].
	html div class: 'notes'; with: [
		self renderNotes: self notes on: html.
		self renderAddOn: html ]! !

!BONoteWidget methodsFor: 'rendering-listing' stamp: 'lr 5/3/2009 12:25'!
renderNote: aNote on: html
	html div class: 'note'; with: [ 
		self renderNoteMeta: aNote on: html.
		self renderNoteBody: aNote on: html ]! !

!BONoteWidget methodsFor: 'rendering-listing' stamp: 'lr 5/3/2009 17:18'!
renderNoteBody: aNote on: html
	| line |
	html div class: 'body'; with: [
		aNote note lines do: [ :string |
			line := string.
			html paragraph: [
				line isEmpty
					ifTrue: [ html space ]
					ifFalse: [
						[ line notEmpty and: [ line first = $ ] ]
							whileTrue: [ html space. line := line copyWithoutFirst ].
						html text: line ] ] ] ]! !

!BONoteWidget methodsFor: 'rendering-listing' stamp: 'lr 5/3/2009 12:33'!
renderNoteMeta: aNote on: html 
	html div class: 'meta'; with: [
		self renderNoteMetaAuthor: aNote on: html.
		self renderNoteMetaPublication: aNote on: html.
		self renderNoteMetaCommands: aNote on: html ]! !

!BONoteWidget methodsFor: 'rendering-listing' stamp: 'lr 5/3/2009 12:32'!
renderNoteMetaAuthor: aNote on: html.
	html span
		class: 'author';
		with: aNote author.
	html text: ' '! !

!BONoteWidget methodsFor: 'rendering-listing' stamp: 'lr 5/3/2009 12:48'!
renderNoteMetaCommands: aNote on: html
	| commands contexts |
	commands := Array with: PREditCommand with: PRMoveCommand with: PRRemoveCommand.
	contexts := (commands
		collect: [ :class | self context structure: aNote command: class new ])
		select: [ :each | each isValid ].
	contexts isEmpty ifTrue: [ ^ self ].
	html span class: 'commands'; with: [
		contexts
			do: [ :each | html anchor goto: each; with: each command label ]
			separatedBy: [ html text: ', ' ] ].
	html text: ' '! !

!BONoteWidget methodsFor: 'rendering-listing' stamp: 'lr 5/3/2009 13:10'!
renderNoteMetaPublication: aNote on: html 
	html span
		class: 'publication';
		with: '(' , aNote timestamp date printString , 
			', ' , aNote timestamp time printMinutes ,
			')'.
	html text: ' '! !

!BONoteWidget methodsFor: 'rendering-listing' stamp: 'lr 5/3/2009 17:15'!
renderNotes: aCollection on: html
	aCollection isEmpty
		ifTrue: [ ^ self ].
	html div class: 'listing'; with: [
		html heading: 'User Contributed Notes'.
		aCollection do: [ :each |
			self renderNote: each on: html ] ]! !

PRCase subclass: #BOPublication
	instanceVariableNames: 'numbered'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book-Structures'!

BOPublication subclass: #BOBook
	instanceVariableNames: 'subtitle tagline authors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book-Structures'!

!BOBook class methodsFor: 'testing' stamp: 'lr 5/13/2009 09:05'!
canBeChildOf: aStructureClass
	^ (aStructureClass includesBehavior: BOPublication) not! !

!BOBook class methodsFor: 'descriptions' stamp: 'lr 4/23/2009 19:38'!
descriptionAuthors
	^ MAStringDescription new
		parameterName: 'authors';
		accessor: #authors;
		label: 'Authors';
		beSearchable;
		priority: 400;
		beEditable;
		yourself! !

!BOBook class methodsFor: 'descriptions' stamp: 'lr 4/23/2009 19:37'!
descriptionSubtitle
	^ MAStringDescription new
		parameterName: 'subtitle';
		accessor: #subtitle;
		label: 'Subtitle';
		beSearchable;
		priority: 200;
		beEditable;
		yourself! !

!BOBook class methodsFor: 'descriptions' stamp: 'lr 4/23/2009 19:37'!
descriptionTagline
	^ MAStringDescription new
		parameterName: 'tagline';
		accessor: #tagline;
		label: 'Tagline';
		beSearchable;
		priority: 300;
		beEditable;
		yourself! !

!BOBook class methodsFor: 'testing' stamp: 'lr 5/2/2009 12:33'!
isAbstract
	^ false! !

!BOBook class methodsFor: 'accessing' stamp: 'lr 4/23/2009 19:31'!
label
	^ 'Book'! !

!BOBook methodsFor: 'visiting' stamp: 'lr 5/13/2009 11:30'!
accept: aVisitor
	aVisitor visitBook: self! !

!BOBook methodsFor: 'accessing' stamp: 'lr 4/23/2009 19:38'!
authors
	^ authors! !

!BOBook methodsFor: 'accessing' stamp: 'lr 4/23/2009 19:38'!
authors: anObject
	authors := anObject! !

!BOBook methodsFor: 'accessing-dynamic' stamp: 'lr 5/2/2009 21:39'!
index
	^ nil! !

!BOBook methodsFor: 'testing' stamp: 'lr 5/2/2009 15:25'!
isBook
	^ true! !

!BOBook methodsFor: 'accessing-dynamic' stamp: 'lr 5/2/2009 21:39'!
number
	^ nil! !

!BOBook methodsFor: 'accessing' stamp: 'lr 4/23/2009 19:38'!
subtitle
	^ subtitle! !

!BOBook methodsFor: 'accessing' stamp: 'lr 4/23/2009 19:38'!
subtitle: aString
	subtitle := aString! !

!BOBook methodsFor: 'accessing' stamp: 'lr 4/23/2009 19:38'!
tagline
	^ tagline! !

!BOBook methodsFor: 'accessing' stamp: 'lr 4/23/2009 19:38'!
tagline: aString
	tagline := aString! !

BOPublication subclass: #BOChapter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book-Structures'!

!BOChapter class methodsFor: 'testing' stamp: 'lr 5/13/2009 09:04'!
canBeChildOf: aStructureClass
	^ (aStructureClass includesBehavior: BOBook) or: [ aStructureClass includesBehavior: BOPart ]! !

!BOChapter class methodsFor: 'accessing' stamp: 'lr 5/2/2009 15:36'!
label
	^ 'Book Chapter'! !

!BOChapter methodsFor: 'visiting' stamp: 'lr 5/13/2009 11:30'!
accept: aVisitor
	aVisitor visitChapter: self! !

!BOChapter methodsFor: 'accessing' stamp: 'lr 5/2/2009 16:14'!
index
	"Answer the chapter of this publication. Chapters can be on different levels, thus we need different numbering algorithm."
	
	| root siblings |
	self parent isNil
		ifTrue: [ ^ nil ].
	root := self parent
		findAncestor: [ :each | each isPublication and: [ each isBook ] ]
		ifAbsent: [ ^ nil ].
	siblings := root enumerator everything
		select: [ :each | each isPublication and: [ each isChapter and: [ each isNumbered ] ] ].
	^ siblings indexOf: self ifAbsent: [ nil ]! !

!BOChapter methodsFor: 'testing' stamp: 'lr 4/24/2009 11:41'!
isChapter
	^ true! !

BOPublication subclass: #BOPart
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book-Structures'!

!BOPart class methodsFor: 'testing' stamp: 'lr 5/2/2009 15:15'!
canBeChildOf: aStructureClass
	^ aStructureClass includesBehavior: BOBook! !

!BOPart class methodsFor: 'accessing' stamp: 'lr 5/2/2009 15:37'!
label
	^ 'Book Part'! !

!BOPart methodsFor: 'visiting' stamp: 'lr 5/13/2009 11:30'!
accept: aVisitor
	aVisitor visitPart: self! !

!BOPart methodsFor: 'private' stamp: 'lr 5/2/2009 15:56'!
arabicToRoman: anInteger
	"Convert an arabic integer to a roman string."
	
	| number roman |
	number := anInteger.
	roman := WriteStream on: String new.
	#((1000 'M') (900 'CM') (500 'D') (400 'CD') (100 'C') (90 'XC') (50 'L') (40 'XL') (10 'X') (9 'IX') (5 'V') (4 'IV') (1 'I')) do: [ :pair |
		[ number >= pair first ] whileTrue: [
			roman nextPutAll: pair second.
			number := number - pair first ] ].
	^ roman contents! !

!BOPart methodsFor: 'accessing' stamp: 'lr 5/2/2009 15:28'!
index
	^ nil! !

!BOPart methodsFor: 'testing' stamp: 'lr 5/2/2009 15:14'!
isPart
	^ true! !

!BOPart methodsFor: 'accessing' stamp: 'lr 5/2/2009 15:56'!
number
	^ self arabicToRoman: super index! !

!BOPublication class methodsFor: 'descriptions' stamp: 'lr 4/24/2009 12:20'!
descriptionNumber
	^ MAStringDescription new
		parameterName: 'number';
		accessor: #number;
		beReadonly;
		yourself! !

!BOPublication class methodsFor: 'descriptions' stamp: 'lr 5/2/2009 16:13'!
descriptionNumbered
	^ MABooleanDescription new
		accessor: #numbered;
		label: 'Numbered';
		default: true;
		priority: 150;
		beEditable;
		yourself! !

!BOPublication class methodsFor: 'testing' stamp: 'lr 4/23/2009 19:21'!
isAbstract
	^ self name = #POPublication! !

!BOPublication methodsFor: 'comparing' stamp: 'lr 4/24/2009 12:10'!
< aStructure
	| siblings |
	(self parent isNil or: [ self parent ~= aStructure parent ])
		ifTrue: [ ^ super < aStructure ].
	(aStructure isPublication)
		ifFalse: [ ^ false ].
	siblings := self parent childrenDecoration children.
	^ (siblings indexOf: self) < (siblings indexOf: aStructure)
		! !

!BOPublication methodsFor: 'visiting' stamp: 'lr 5/13/2009 11:30'!
accept: aVisitor
	aVisitor visitPublication: self! !

!BOPublication methodsFor: 'accessing' stamp: 'lr 5/2/2009 16:14'!
index
	"Answer the index number of this publication, for example the chapter or section number."
	
	| siblings |
	self parent isNil
		ifTrue: [ ^ nil ].
	siblings := self parent childrenDecoration children select: [ :each | 
		each isPublication 
			and: [ each isNumbered
			and: [ each class = self class ] ] ].
	^ siblings indexOf: self ifAbsent: [ nil ]! !

!BOPublication methodsFor: 'testing' stamp: 'lr 5/2/2009 15:26'!
isBook
	^ false! !

!BOPublication methodsFor: 'testing' stamp: 'lr 4/24/2009 11:40'!
isChapter
	^ false! !

!BOPublication methodsFor: 'testing' stamp: 'lr 5/2/2009 16:13'!
isNumbered
	^ numbered ifNil: [ true ]! !

!BOPublication methodsFor: 'testing' stamp: 'lr 5/2/2009 15:14'!
isPart
	^ false! !

!BOPublication methodsFor: 'testing' stamp: 'lr 4/23/2009 19:32'!
isPublication
	^ true! !

!BOPublication methodsFor: 'testing' stamp: 'lr 4/24/2009 11:41'!
isSection
	^ false! !

!BOPublication methodsFor: 'testing' stamp: 'lr 4/24/2009 11:41'!
isSubsection
	^ false! !

!BOPublication methodsFor: 'accessing' stamp: 'lr 5/2/2009 15:33'!
number
	"Answer the composed numbers."

	| book publications |
	book := self 
		findAncestor: [ :each | each isPublication and: [ each isBook ] ]
		ifAbsent: [ ^ nil ].
	publications := (self parents
		select: [ :each | each isPublication ])
		copyAfter: book.
	^ (((publications	
		collect: [ :each | each index ])
		reject: [ :each | each isNil ])
		collect: [ :each | each asString ])
		reduce: [ :a :b | a , '.' , b ]! !

!BOPublication methodsFor: 'accessing' stamp: 'lr 5/2/2009 16:13'!
numbered
	^ numbered! !

!BOPublication methodsFor: 'accessing' stamp: 'lr 5/2/2009 16:12'!
numbered: aBoolean
	numbered := aBoolean! !

BOPublication subclass: #BOSection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book-Structures'!

!BOSection class methodsFor: 'testing' stamp: 'lr 4/23/2009 19:34'!
canBeChildOf: aStructureClass
	^ aStructureClass includesBehavior: BOChapter! !

!BOSection class methodsFor: 'accessing' stamp: 'lr 5/2/2009 15:36'!
label
	^ 'Book Section'! !

!BOSection methodsFor: 'visiting' stamp: 'lr 5/13/2009 11:30'!
accept: aVisitor
	aVisitor visitSection: self! !

!BOSection methodsFor: 'testing' stamp: 'lr 4/24/2009 11:41'!
isSection
	^ true! !

BOPublication subclass: #BOSubsection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book-Structures'!

!BOSubsection class methodsFor: 'testing' stamp: 'lr 4/23/2009 19:33'!
canBeChildOf: aStructureClass
	^ aStructureClass includesBehavior: BOSection! !

!BOSubsection class methodsFor: 'accessing' stamp: 'lr 5/2/2009 15:36'!
label
	^ 'Book Subsection'! !

!BOSubsection methodsFor: 'visiting' stamp: 'lr 5/13/2009 11:31'!
accept: aVisitor
	aVisitor visitSubsection: self! !

!BOSubsection methodsFor: 'testing' stamp: 'lr 4/24/2009 11:41'!
isSubsection
	^ true! !

!PRVisitor methodsFor: '*pier-book' stamp: 'lr 5/13/2009 11:16'!
visitBook: aStructure
	self visitPublication: aStructure! !

!PRVisitor methodsFor: '*pier-book' stamp: 'lr 5/13/2009 11:17'!
visitChapter: aStructure
	self visitPublication: aStructure! !

!PRVisitor methodsFor: '*pier-book' stamp: 'lr 5/1/2009 22:11'!
visitIndexLink: aLink
	self visitLink: aLink! !

!PRVisitor methodsFor: '*pier-book' stamp: 'lr 5/13/2009 11:17'!
visitPart: aStructure
	self visitPublication: aStructure! !

!PRVisitor methodsFor: '*pier-book' stamp: 'lr 5/13/2009 11:16'!
visitPublication: aStructure
	self visitCase: aStructure! !

!PRVisitor methodsFor: '*pier-book' stamp: 'lr 5/13/2009 11:17'!
visitSection: aStructure
	self visitPublication: aStructure! !

!PRVisitor methodsFor: '*pier-book' stamp: 'lr 5/13/2009 11:17'!
visitSubsection: aStructure
	self visitPublication: aStructure! !

Object subclass: #BOLatexBuilder
	instanceVariableNames: 'package directory name stream classes categories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book-Latex'!

!BOLatexBuilder class methodsFor: 'building' stamp: 'lr 5/13/2009 08:59'!
build
	"The default build script for my master."

	self
		build: (PackageInfo named: 'Magritte-Model')
		in: FileDirectory default named: 'magritte.tex'.
	self
		build: (PackageInfo named: 'Pier-Model')
		in: FileDirectory default named: 'pier.tex'! !

!BOLatexBuilder class methodsFor: 'building' stamp: 'lr 5/13/2009 08:59'!
build: aPackage in: aDirectory named: aString
	^ self new
		setPackage: aPackage;
		setDirectory: aDirectory;
		setName: aString;
		build! !

!BOLatexBuilder methodsFor: 'building' stamp: 'lr 5/13/2009 08:59'!
build
	| output |
	stream := PRLatexStream on: String new.
	self buildHeader; buildBody; buildFooter.
	output := self directory forceNewFileNamed: self name.
	[ output nextPutAll: stream contents ] ensure: [ output close ]! !

!BOLatexBuilder methodsFor: 'building' stamp: 'lr 5/13/2009 08:59'!
buildBody
	classes := (self package classes select: [ :each | each hasComment ]) asSet.
	categories := (classes collect: [ :each | each category ]) asSet.
	self package systemCategories
		do: [ :each |
			(categories includes: each)
				ifTrue: [ self buildCategory: each ] ]
		displayingProgress: self package packageName.! !

!BOLatexBuilder methodsFor: 'building' stamp: 'lr 5/13/2009 08:59'!
buildCategory: aSymbol
	stream
		"tag: 'phantomsection'; cr;"
		tag: 'addcontentsline'; curly: 'toc'; curly: 'section'; curly: aSymbol; cr;
		tag: 'section*'; curly: [
			stream
				print: aSymbol;
				tag: 'label'; curly: aSymbol ];
		cr; cr.
	((classes
		select: [ :each | each category = aSymbol ])
		asSortedCollection: [ :a :b | a name <= b name ])
		do: [ :each | self buildClass: each ]! !

!BOLatexBuilder methodsFor: 'building' stamp: 'lr 5/13/2009 08:59'!
buildClass: aClass 
	stream 
		tag: 'phantomsection'; cr;
		tag: 'addcontentsline'; curly: 'toc'; curly: 'subsection'; curly: aClass name; cr;
		tag: 'subsection*'; curly: [
			stream
				print: aClass name;
				tag: 'label'; curly: aClass name;
				tag: 'index'; curly: (aClass name allButFirst: 2) ];
		cr; cr.
	self
		buildClassEnum: aClass allSuperclasses allButLast reverse
		labelled: 'Superclasses' on: stream.
	self
		buildClassEnum: ((aClass allSubclasses
			select: [ :each | classes includes: each ])
			asSortedCollection: [ :a :b | a name <= b name ])
		labelled: 'Subclasses' on: stream.
	self wiki: aClass organization classComment offset: 3.
	(self package coreCategoriesForClass: aClass) asSortedCollection
		do: [ :each | self buildClass: aClass category: each ]! !

!BOLatexBuilder methodsFor: 'building' stamp: 'lr 5/13/2009 08:59'!
buildClass: aClass category: aString
	(Categorizer allCategory = aString
		or: [ Categorizer nullCategory = aString ]
		or: [ aString beginsWith: 'private' ])
			ifTrue: [ ^ self ].
	((aClass organization listAtCategoryNamed: aString)
		allSatisfy: [ :each | (aClass firstPrecodeCommentFor: each) isEmptyOrNil ])
			ifTrue: [ ^ self ].
	stream tag: 'subsubsection*'; curly: aString; cr.
	stream environment: 'itemize' do: [
		(aClass organization listAtCategoryNamed: aString) asSortedCollection
			do: [ :each | self buildClass: aClass category: aString selector: each ] ].
	stream cr; cr
! !

!BOLatexBuilder methodsFor: 'building' stamp: 'lr 5/13/2009 08:59'!
buildClass: aClass category: aString selector: aSelector
	| source |
	source := aClass firstPrecodeCommentFor: aSelector.
	source isEmptyOrNil ifTrue: [ ^ self ].
	stream 
		tag: 'item'; cr;
		tab; tag: 'index'; curly: aSelector; cr;
		tab; tag: 'label'; curly: aClass name , '-' , aSelector; cr;
		tab; tag: 'index'; curly: (aClass name allButFirst: 2) , '!!#' , aSelector; cr;
		tab; tag: 'code'; curly: [ stream nextPutClose: (aClass methodHeaderFor: aSelector) ];
		basicPutAll: ' \\'; cr.
	self wiki: source offset: 4.
	stream cr! !

!BOLatexBuilder methodsFor: 'building-tools' stamp: 'lr 5/13/2009 08:59'!
buildClassEnum: aCollection labelled: aString on: aStream
	aCollection isEmpty ifTrue: [ ^ self ].
	aStream environment: 'sloppypar' do: [
		aStream tag: 'paragraph'; curly: aString; cr.
		aCollection
			do: [ :each |
				aStream tag: 'code'; curly: [
					(classes includes: each)
						ifFalse: [ aStream basicPutAll: each name hyphenate ]
						ifTrue: [ 
							aStream tag: 'hyperref'; square: each name; curly: [
							aStream basicPutAll: each name hyphenate ] ] ] ]
			separatedBy: [ aStream nextPutAll: ', ' ].
		aStream cr ].
	aStream cr; cr! !

!BOLatexBuilder methodsFor: 'building' stamp: 'lr 5/13/2009 08:59'!
buildFooter
	stream tag: 'addcontentsline{toc}{chapter}{\indexname}'; cr.
	stream tag: 'printindex'; cr.
	stream tag: 'end'; curly: 'document'! !

!BOLatexBuilder methodsFor: 'building' stamp: 'lr 5/13/2009 08:59'!
buildHeader
	stream tag: 'documentclass'; square: 'a4paper,11pt'; curly: 'article'; cr.
	stream cr.
	
	stream comment: 'packages'.
	stream tag: 'usepackage'; curly: 'color'; cr.
	stream tag: 'usepackage'; curly: 'hyperref'; cr.
	stream tag: 'usepackage'; curly: 'verbatim'; cr.
	stream tag: 'usepackage'; curly: 'moreverb'; cr.
	stream tag: 'usepackage'; curly: 'makeidx'; cr.
	stream tag: 'usepackage'; square: 'parfill'; curly: 'parskip'; cr.
	stream cr.
	
	stream comment: 'settings'.
	stream tag: 'makeindex'; cr.
	stream tag: 'definecolor'; curly: 'darkblue'; curly: 'rgb'; curly: '0,0,0.4'; cr.
	stream tag: 'hypersetup'; curly: 'colorlinks=true,linkcolor=darkblue,anchorcolor=darkblue,citecolor=darkblue,filecolor=darkblue,pagecolor=darkblue,urlcolor=darkblue,plainpages=false,bookmarksopen=true,bookmarksopenlevel=1'; cr.	
	stream tag: 'newcommand'; basicPutAll: '{\code}[1]{{\texttt{#1}}}'; cr.
	stream tag: 'newenvironment'; basicPutAll: '{source}[0]{\vspace{-8pt}\obeylines\obeyspaces\verbatimtab\footnotesize\texttt}{\endtrivlist\normalsize}'; cr.
	stream cr.
	
	stream comment: 'title'.
	stream tag: 'title'; curly: (package packageName copyUpTo: $-); cr.
	stream tag: 'author'; curly: [
		stream nextPutAll: 'Lukas Renggli'; basicPutAll: '\\ '.
		stream tag: 'url'; basicPutAll: '{http://www.lukas-renggli.ch}' ]; cr.
	stream tag: 'date'; curly: Date today; cr.
	stream cr.
	
	stream comment: 'document'.
	stream tag: 'begin'; curly: 'document'; cr.
	stream tag: 'maketitle'; cr! !

!BOLatexBuilder methodsFor: 'accessing' stamp: 'lr 5/13/2009 08:59'!
directory
	^ directory! !

!BOLatexBuilder methodsFor: 'accessing' stamp: 'lr 5/13/2009 08:59'!
name
	^ name! !

!BOLatexBuilder methodsFor: 'accessing' stamp: 'lr 5/13/2009 08:59'!
package
	^ package! !

!BOLatexBuilder methodsFor: 'initialization' stamp: 'lr 5/13/2009 08:59'!
setDirectory: aDirectory
	directory := aDirectory assureExistence! !

!BOLatexBuilder methodsFor: 'initialization' stamp: 'lr 5/13/2009 08:59'!
setName: aString
	name := aString! !

!BOLatexBuilder methodsFor: 'initialization' stamp: 'lr 5/13/2009 08:59'!
setPackage: aPackage
	package := aPackage! !

!BOLatexBuilder methodsFor: 'private' stamp: 'lr 5/13/2009 08:59'!
wiki: aString offset: anInteger
	PRLatexWriter
		format: (PRDocumentParser parse: (aString ifNil: [ String new ]))
		offset: anInteger on: stream.
	stream cr; cr! !

Object subclass: #BOLatexWrapper
	instanceVariableNames: 'stream'
	classVariableNames: 'LatexCharacters'
	poolDictionaries: ''
	category: 'Pier-Book-Latex'!

!BOLatexWrapper class methodsFor: 'initialization' stamp: 'lr 5/13/2009 08:59'!
initialize
	LatexCharacters := Dictionary new.
	LatexCharacters
		at: $# put: '\#';
		at: $& put: '\&';
		at: $% put: '\%';
		at: $$ put: '\$';
		at: ${ put: '\{';
		at: $} put: '\}';
		at: $" put: '\symbol{34}';
		" -- "
		at: $[ put: '{[}';
		at: $] put: '{]}';
		at: $| put: '$|$';
		at: $< put: '$<$';
		at: $> put: '$>$';
		at: $/ put: '$/$';
		at: $\ put: '$\backslash$';
		at: $_ put: '$\leftarrow$';
		at: $^ put: '$\uparrow$';
		" -- "
		at: $ put: '\"{a}';
		at: $ put: '\"{A}';
		at: $ put: '\"{e}';
		at: $ put: '\"{E}';
		at: $ put: '\"{i}';
		at: $ put: '\"{I}';
		at: $ put: '\"{o}';
		at: $ put: '\"{O}';
		at: $ put: '\"{u}';
		at: $ put: '\"{U}';
		at: $ put: '\"{y}';
		at: $ put: '\"{Y}';
		" -- "
		at: $ put: '\^{a}';
		at: $ put: '\^{A}';
		at: $ put: '\^{e}';
		at: $ put: '\^{E}';
		at: $ put: '\^{i}';
		at: $ put: '\^{I}';
		at: $ put: '\^{o}';
		at: $ put: '\^{O}';
		at: $ put: '\^{u}';
		at: $ put: '\^{U}';
		" -- "
		at: $ put: '\`{a}';
		at: $ put: '\`{A}';
		at: $ put: '\`{e}';
		at: $ put: '\`{E}';
		at: $ put: '\`{i}';
		at: $ put: '\`{I}';
		at: $ put: '\`{o}';
		at: $ put: '\`{O}';
		at: $ put: '\`{u}';
		at: $ put: '\`{U}';
		" -- "
		at: $ put: '\''{a}';
		at: $ put: '\''{A}';
		at: $ put: '\''{e}';
		at: $ put: '\''{i}';
		at: $ put: '\''{I}';
		at: $ put: '\''{o}';
		at: $ put: '\''{O}';
		at: $ put: '\''{u}';
		at: $ put: '\''{U}';
		" -- "
		at: $ put: '\c{c}';
		at: $ put: '\c{C}';
		" -- "
		at: $~ put: '\~{}';
		at: $ put: '\~{n}';
		at: $ put: '\~{N}'! !

!BOLatexWrapper class methodsFor: 'instance creation' stamp: 'lr 5/13/2009 11:21'!
on: aStream
	^ self basicNew initializeOn: aStream! !

!BOLatexWrapper methodsFor: 'private' stamp: 'lr 5/13/2009 09:10'!
basicPut: aCharacter
	self stream nextPut: aCharacter! !

!BOLatexWrapper methodsFor: 'private' stamp: 'lr 5/13/2009 09:10'!
basicPutAll: aString
	self stream nextPutAll: aString! !

!BOLatexWrapper methodsFor: 'conveniance' stamp: 'lr 5/13/2009 08:59'!
comment: anObject
	self basicPut: $%; space; basicPutAll: anObject asString; cr! !

!BOLatexWrapper methodsFor: 'accessing' stamp: 'lr 5/13/2009 11:24'!
contents
	^ stream contents! !

!BOLatexWrapper methodsFor: 'streaming' stamp: 'lr 5/13/2009 09:14'!
cr
	(self stream position isZero
		or: [ self stream position > 1
		and: [ (self stream peek) = Character cr
		and: [ (self stream back; next) = Character cr ] ] ])
			ifTrue: [ ^ self ].
	self stream cr! !

!BOLatexWrapper methodsFor: 'conveniance' stamp: 'lr 5/13/2009 08:59'!
curly: anObject
	self basicPut: ${; print: anObject; basicPut: $}! !

!BOLatexWrapper methodsFor: 'conveniance' stamp: 'lr 5/13/2009 08:59'!
environment: aString do: anObject
	self tag: 'begin'; curly: aString; cr.
	self print: anObject.
	self tag: 'end'; curly: aString; cr! !

!BOLatexWrapper methodsFor: 'initialization' stamp: 'lr 5/13/2009 09:09'!
initializeOn: aStream
	stream := aStream! !

!BOLatexWrapper methodsFor: 'testing' stamp: 'lr 5/13/2009 11:23'!
isEmpty
	^ stream isEmpty! !

!BOLatexWrapper methodsFor: 'streaming' stamp: 'lr 5/13/2009 11:31'!
nextPut: aCharacter
	| string |
	string := LatexCharacters at: aCharacter ifAbsent: nil.
	string isNil
		ifTrue: [ self basicPut: aCharacter ]
		ifFalse: [ self basicPutAll: string ]! !

!BOLatexWrapper methodsFor: 'streaming' stamp: 'lr 5/13/2009 08:59'!
nextPutAll: anObject
	anObject asString do: [ :each | self nextPut: each ]! !

!BOLatexWrapper methodsFor: 'streaming' stamp: 'lr 5/13/2009 08:59'!
nextPutClose: anObject
	anObject asString do: [ :each | 
		Character space = each
			ifTrue: [ self basicPut: $~ ]
			ifFalse: [ self nextPut: each ] ]! !

!BOLatexWrapper methodsFor: 'streaming' stamp: 'lr 5/13/2009 08:59'!
print: anObject
	anObject printLatexOn: self! !

!BOLatexWrapper methodsFor: 'streaming' stamp: 'lr 5/13/2009 11:41'!
space
	self stream space! !

!BOLatexWrapper methodsFor: 'conveniance' stamp: 'lr 5/13/2009 08:59'!
square: anObject
	self basicPut: $[; print: anObject; basicPut: $]! !

!BOLatexWrapper methodsFor: 'accessing' stamp: 'lr 5/13/2009 11:04'!
stream
	^ stream! !

!BOLatexWrapper methodsFor: 'conveniance' stamp: 'lr 5/13/2009 08:59'!
tag: aString
	self basicPut: $\; basicPutAll: aString! !

!PRLinkRenderer methodsFor: '*pier-book' stamp: 'lr 5/1/2009 22:35'!
visitIndexLink: aLink
	html anchor name: aLink title.
	parent visitAll: aLink children! !

PRDocumentWriter subclass: #BOLatexWriter
	instanceVariableNames: 'structures latex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book-Latex'!

!BOLatexWriter methodsFor: 'accessing' stamp: 'lr 5/13/2009 11:49'!
stream: aStream
	super stream: aStream.
	latex := BOLatexWrapper on: aStream.
	structures := OrderedCollection new! !

!BOLatexWriter methodsFor: 'visiting' stamp: 'lr 5/13/2009 11:50'!
visit: anObject
	| isPublication |
	isPublication := anObject isKindOf: BOPublication.
	isPublication
		ifTrue: [ structures addLast: anObject ].
	super visit: anObject.
	isPublication
		ifTrue: [ structures removeLast ]! !

!BOLatexWriter methodsFor: 'visiting-document' stamp: 'lr 5/13/2009 11:35'!
visitAnchor: anObject
	latex tag: 'label'; curly: anObject name; cr! !

!BOLatexWriter methodsFor: 'visiting-formatting' stamp: 'lr 5/13/2009 11:37'!
visitBoldFormat: anObject
	latex tag: 'textbf'; curly: [ super visitBoldFormat: anObject ]! !

!BOLatexWriter methodsFor: 'visiting-structure' stamp: 'lr 5/13/2009 11:19'!
visitBook: aStructure
	super visitBook: aStructure! !

!BOLatexWriter methodsFor: 'visiting-structure' stamp: 'lr 5/13/2009 11:34'!
visitCase: aStructure
	super visitCase: aStructure.
	self visit: aStructure document! !

!BOLatexWriter methodsFor: 'visiting-structure' stamp: 'lr 5/13/2009 11:54'!
visitChapter: aStructure
	latex
		tag: 'chapter';
		print: (aStructure isNumbered ifFalse: [ '*' ]);
		curly: aStructure title; cr.
	super visitChapter: aStructure! !

!BOLatexWriter methodsFor: 'visiting-document' stamp: 'lr 5/13/2009 11:36'!
visitDefinitionList: anObject
	latex environment: 'definition' do: [ super visitDefinitionList: anObject ]! !

!BOLatexWriter methodsFor: 'visiting-document' stamp: 'lr 5/13/2009 11:36'!
visitEmptyParagraph: anObject
	latex cr! !

!BOLatexWriter methodsFor: 'visiting-document' stamp: 'lr 5/13/2009 11:51'!
visitExternalLink: anObject
	latex
		tag: 'href';
		curly: [ stream nextPutAll: anObject url ];
		curly: [ super visitExternalLink: anObject ]! !

!BOLatexWriter methodsFor: 'visiting-document' stamp: 'lr 5/13/2009 11:36'!
visitHeader: anObject
	| kind |
	kind := #('subsubsection' 'paragraph' 'subparagraph')
		at: (anObject level max: 3).
	latex tag: kind; basicPut: $*; curly: anObject text; cr! !

!BOLatexWriter methodsFor: 'visiting-document' stamp: 'lr 5/13/2009 12:01'!
visitIndexLink: anObject
	latex tag: 'index'; curly: anObject title! !

!BOLatexWriter methodsFor: 'visiting-document' stamp: 'lr 5/13/2009 11:36'!
visitInternalLink: anObject
	latex
		tag: 'hyperref';
		square: [ self stream basicPutAll: anObject reference ];
		curly: [ super visitInternalLink: anObject ]! !

!BOLatexWriter methodsFor: 'visiting-formatting' stamp: 'lr 5/13/2009 11:37'!
visitItalicFormat: anObject
	latex tag: 'textit'; curly: [ super visitItalicFormat: anObject ]! !

!BOLatexWriter methodsFor: 'visiting-document' stamp: 'lr 5/13/2009 11:36'!
visitLineBreak: anObject
	latex cr! !

!BOLatexWriter methodsFor: 'visiting-document' stamp: 'lr 5/13/2009 11:36'!
visitLink: anObject
	anObject hasChildren
		ifTrue: [ super visitLink: anObject ]
		ifFalse: [ latex print: anObject reference ]! !

!BOLatexWriter methodsFor: 'visiting-document' stamp: 'lr 5/13/2009 11:36'!
visitListItem: anObject
	latex tag: 'item'; space.
	super visitListItem: anObject.
	latex cr! !

!BOLatexWriter methodsFor: 'visiting-formatting' stamp: 'lr 5/13/2009 11:37'!
visitMonospaceFormat: anObject
	latex tag: 'texttt'; curly: [ super visitMonospaceFormat: anObject ]! !

!BOLatexWriter methodsFor: 'visiting-document' stamp: 'lr 5/13/2009 11:36'!
visitOrderedList: anObject
	latex environment: 'enumerate' do: [ super visitOrderedList: anObject ]! !

!BOLatexWriter methodsFor: 'visiting-document' stamp: 'lr 5/13/2009 11:36'!
visitParagraph: anObject
	super visitParagraph: anObject.
	latex cr; cr! !

!BOLatexWriter methodsFor: 'visiting-structure' stamp: 'lr 5/13/2009 11:54'!
visitPart: aStructure
	latex
		tag: 'part';
		print: (aStructure isNumbered ifFalse: [ '*' ]);
		curly: aStructure title; cr.
	super visitPart: aStructure! !

!BOLatexWriter methodsFor: 'visiting-document' stamp: 'lr 5/13/2009 11:36'!
visitPreformatted: anObject
	latex environment: 'source' do: [
		anObject children do: [ :each |
			latex basicPutAll: each text; cr ] ]! !

!BOLatexWriter methodsFor: 'visiting-structure' stamp: 'lr 5/13/2009 11:25'!
visitPublication: aStructure
	super visitPublication: aStructure.
	aStructure enumerator do: [ :structure |
		structure isPublication
			ifTrue: [ self visit: structure ] ]! !

!BOLatexWriter methodsFor: 'visiting-structure' stamp: 'lr 5/13/2009 11:54'!
visitSection: aStructure
	latex
		tag: 'section';
		print: (aStructure isNumbered ifFalse: [ '*' ]);
		curly: aStructure title; cr.
	super visitSection: aStructure! !

!BOLatexWriter methodsFor: 'visiting-formatting' stamp: 'lr 5/13/2009 11:37'!
visitStrikethroughFormat: anObject
	latex tag: 'sout'; curly: [ super visitStrikethroughFormat: anObject ]! !

!BOLatexWriter methodsFor: 'visiting-formatting' stamp: 'lr 5/13/2009 11:37'!
visitSubscriptFormat: anObject
	latex tag: 'raisebox'; curly: '-0.25em'; curly: [ super visitSubscriptFormat: anObject ]! !

!BOLatexWriter methodsFor: 'visiting-structure' stamp: 'lr 5/13/2009 11:55'!
visitSubsection: aStructure
	latex
		tag: 'subsection';
		print: (aStructure isNumbered ifFalse: [ '*' ]);
		curly: aStructure title; cr.
	self visitSubsection: aStructure! !

!BOLatexWriter methodsFor: 'visiting-formatting' stamp: 'lr 5/13/2009 11:37'!
visitSuperscriptFormat: anObject
	latex tag: 'raisebox'; curly: '0.25em'; curly: [ super visitSuperscriptFormat: anObject ]! !

!BOLatexWriter methodsFor: 'visiting-document' stamp: 'lr 5/13/2009 11:37'!
visitTable: anObject
	latex environment: 'tabular' do: [
		latex curly: (String new: anObject columnCount withAll: $l); cr.
		self visitAll: anObject children separatedBy: [ latex basicPutAll: '\\'; cr ] ]! !

!BOLatexWriter methodsFor: 'visiting-document' stamp: 'lr 5/13/2009 11:37'!
visitTableRow: aTableRow
	self visitAll: aTableRow children separatedBy: [ latex basicPut: $& ]! !

!BOLatexWriter methodsFor: 'visiting-document' stamp: 'lr 5/13/2009 11:37'!
visitText: anObject
	latex nextPutAll: anObject text! !

!BOLatexWriter methodsFor: 'visiting-formatting' stamp: 'lr 5/13/2009 11:37'!
visitUnderlineFormat: anObject
	latex tag: 'uline'; curly: [ super visitUnderlineFormat: anObject ]! !

!BOLatexWriter methodsFor: 'visiting-document' stamp: 'lr 5/13/2009 11:37'!
visitUnorderedList: anObject
	latex environment: 'itemize' do: [ super visitUnorderedList: anObject ]! !

!BOLatexWriter methodsFor: 'visiting-document' stamp: 'lr 5/13/2009 11:59'!
visitValueLink: anObject
	| value |
	value := anObject valueIn: self context.
	value isNil
		ifTrue: [ ^ self visitLink: anObject ].
	(value isCollection and: [ value isString not ])
		ifTrue: [ ^ self visitAll: value ].
	(value isKindOf: PRDocumentItem)
		ifTrue: [ ^ self visit: value ].
	latex print: value! !

!PRValueLink methodsFor: '*pier-book' stamp: 'lr 5/2/2009 16:21'!
bookContentsIn: aContext
	<value: 'book.contents' comment: 'Display a table of contents.'>

	| result |
	^ self lookupStructure: aContext structure do: [ :root |
		result := PRDefinitionList new.
		root enumerator everything do: [ :structure |
			(structure isPublication and: [ structure isBook not ]) ifTrue: [
				self 
					bookLabel: (structure number 
						ifNil: [ ' ' ])
					target: structure 
					to: result ] ].
		result ]! !

!PRValueLink methodsFor: '*pier-book' stamp: 'lr 5/2/2009 16:29'!
bookIndexIn: aContext
	<value: 'book.index' comment: 'Display an index of keywords.'>

	| structs |
	^ self lookupStructure: aContext structure do: [ :root |
		| index |
		index := Dictionary new.
		root enumerator everything do: [ :struct |
			struct outgoingReferences do: [ :refer |
				(refer isKindOf: BOIndexLink) ifTrue: [ 
					(index at: refer title ifAbsentPut: [ OrderedCollection new ])
						addLast: refer owner ] ] ].
		(index keys asSortedCollection: [ :a :b | a asLowercase < b asLowercase ])
			inject: PRDefinitionList new
			into: [ :list :word |
				structs := Set new.
				list add: (PRTermItem with: (PRText content: word)).
				(index at: word) do: [ :struct |
					(structs includes: struct) ifFalse: [ 
						structs add: struct.
						list add: (PRDataItem with: (PRInternalLink new
							anchor: word;
							target: struct;
							yourself)) ] ].
				list ] ]! !

!PRValueLink methodsFor: '*pier-book-private' stamp: 'lr 5/2/2009 21:35'!
bookLabel: aString target: aStructure to: aDefinitionList
	| number |
	^ aDefinitionList
		add: (PRTermItem with: (PRText content: (aStructure isNil
			ifTrue: [ '&nbsp;' ]
			ifFalse: [ aString ])));
		add: (PRDataItem with: (aStructure isNil
			ifTrue: [ PRText content: '&nbsp;' ]
			ifFalse: [
				number := aStructure number.
				number isNil 
					ifTrue: [ number := String new ]
					ifFalse: [ number := number , ' ' ].
				PRInternalLink new 
					parameterAt: 'title' put: number , aStructure title;
					target: aStructure;
					yourself ]));
		yourself! !

!PRValueLink methodsFor: '*pier-book' stamp: 'lr 5/2/2009 09:56'!
bookNavigationIn: aContext
	<value: 'book.navigation' comment: 'Display a navigation structure for books.'>

	| structures index result |
	^ self lookupStructure: aContext structure do: [ :structure |
		structures := (aContext enumeratorFor: aContext root) everything
			select: [ :each | each isPublication ].
		index := structures indexOf: (structure 
			findAncestor: [ :each | each isPublication ]).
		result := PRDefinitionList new.
		self 
			bookLabel: '&rarr;' target: (structures at: index + 1 ifAbsent: [ nil ]) to: result;
			bookLabel: '&larr;' target: (structures at: index - 1 ifAbsent: [ nil ]) to: result ]! !

!PRValueLink methodsFor: '*pier-book' stamp: 'lr 5/2/2009 10:06'!
bookParentIn: aContext
	<value: 'book.parent' comment: 'Display the parent structure for books.'>

	^ self lookupStructure: aContext structure do: [ :structure |
		self 
			bookLabel: '&sect;' 
			target: (structure isRoot
				ifFalse: [ structure parent findAncestor: [ :each | each isPublication ] ]) 
			to: PRDefinitionList new ]! !
BOLatexWrapper initialize!
